Index: /ruby/trunk/db/migrate/20100705070022_create_territories.rb
===================================================================
--- /ruby/trunk/db/migrate/20100705070022_create_territories.rb	(revision 420)
+++ /ruby/trunk/db/migrate/20100705070022_create_territories.rb	(revision 420)
@@ -0,0 +1,14 @@
+class CreateTerritories < ActiveRecord::Migration
+  def self.up
+    create_table :territories do |t|
+      t.string :text
+      t.string :three_letter
+      t.string :numeric_code
+      t.string :two_letter
+    end
+  end
+
+  def self.down
+    drop_table :territories
+  end
+end
Index: /ruby/trunk/db/migrate/20100705082838_create_terminology_identifiers.rb
===================================================================
--- /ruby/trunk/db/migrate/20100705082838_create_terminology_identifiers.rb	(revision 420)
+++ /ruby/trunk/db/migrate/20100705082838_create_terminology_identifiers.rb	(revision 420)
@@ -0,0 +1,13 @@
+class CreateTerminologyIdentifiers < ActiveRecord::Migration
+  def self.up
+    create_table :terminology_identifiers do |t|
+      t.string :vsab
+      t.string :authority
+      t.string :source_name
+    end
+  end
+
+  def self.down
+    drop_table :terminology_identifiers
+  end
+end
Index: /ruby/trunk/db/schema.rb
===================================================================
--- /ruby/trunk/db/schema.rb	(revision 419)
+++ /ruby/trunk/db/schema.rb	(revision 420)
@@ -10,5 +10,5 @@
 # It's strongly recommended to check this file into your version control system.
 
-ActiveRecord::Schema.define(:version => 20100702073455) do
+ActiveRecord::Schema.define(:version => 20100705082838) do
 
   create_table "archetype_data", :force => true do |t|
@@ -41,3 +41,16 @@
   end
 
+  create_table "terminology_identifiers", :force => true do |t|
+    t.string "vsab"
+    t.string "authority"
+    t.string "source_name"
+  end
+
+  create_table "territories", :force => true do |t|
+    t.string "text"
+    t.string "three_letter"
+    t.string "numeric_code"
+    t.string "two_letter"
+  end
+
 end
Index: /ruby/trunk/db/seeds.rb
===================================================================
--- /ruby/trunk/db/seeds.rb	(revision 420)
+++ /ruby/trunk/db/seeds.rb	(revision 420)
@@ -0,0 +1,12 @@
+terminology = OpenEHR::Terminology::OpenEHRTerminology.new
+
+terminology.languages.each do |lang|
+  Language.create!(:code => lang['code'], :description => lang['Description'])
+end
+
+terminology.territories.each do |territory|
+  Territory.create!(:text => territory['Text'],
+                    :three_letter => territory['ThreeLetter'],
+                    :numeric_code => territory['NumericCode'],
+                    :two_letter => territory['TwoLetter'])
+end
Index: /ruby/trunk/spec/fixtures/terminology_identifiers.yml
===================================================================
--- /ruby/trunk/spec/fixtures/terminology_identifiers.yml	(revision 420)
+++ /ruby/trunk/spec/fixtures/terminology_identifiers.yml	(revision 420)
@@ -0,0 +1,11 @@
+# Read about fixtures at http://ar.rubyonrails.org/classes/Fixtures.html
+
+AIR93:
+  vsab: AIR93
+  authority: UMLS2003AA
+  source_name: AI/RHEUM,1993
+
+ALT2000:
+  vsab: ALT2000
+  authority: UMLS2003AA
+  source_name: Alternative Billing Concepts, 2000
Index: /ruby/trunk/spec/fixtures/territories.yml
===================================================================
--- /ruby/trunk/spec/fixtures/territories.yml	(revision 420)
+++ /ruby/trunk/spec/fixtures/territories.yml	(revision 420)
@@ -0,0 +1,13 @@
+# Read about fixtures at http://ar.rubyonrails.org/classes/Fixtures.html
+
+Afghanistan:
+  text: Afghanistan
+  three_letter: AFG
+  numeric_code: 004
+  two_letter: AF
+
+Albania:
+  text: Albania, People's Socialist Republic of
+  three_letter: ALB
+  numeric_code: 008
+  two_letter: AL
Index: /ruby/trunk/spec/models/terminology_identifier_spec.rb
===================================================================
--- /ruby/trunk/spec/models/terminology_identifier_spec.rb	(revision 420)
+++ /ruby/trunk/spec/models/terminology_identifier_spec.rb	(revision 420)
@@ -0,0 +1,25 @@
+require 'spec_helper'
+
+describe TerminologyIdentifier do
+  fixtures :terminology_identifiers
+
+  before(:each) do
+    @valid_attributes = {
+      :vsab => "SNOMED-CT",
+      :authority => "openEHR 2003",
+      :source_name => "SNOMED International Clinical Terms, 2002"
+    }
+  end
+
+  it "should create a new instance given valid attributes" do
+    TerminologyIdentifier.create!(@valid_attributes)
+  end
+
+  it 'should return true if vsab is on the table' do
+    TerminologyIdentifier.should have_vsab 'AIR93'
+  end
+
+  it 'should not return true if vsab is out of the table' do
+    TerminologyIdentifier.should_not have_vsab 'ZZZZZZZ'
+  end
+end
Index: /ruby/trunk/spec/models/terminology_spec.rb
===================================================================
--- /ruby/trunk/spec/models/terminology_spec.rb	(revision 419)
+++ /ruby/trunk/spec/models/terminology_spec.rb	(revision 420)
@@ -6,6 +6,6 @@
   end
 
-  it 'has_language_code should true if it has' do
-    @terminology.should have_language_code 'en'
-  end
+  it 'has_language_code should true if it has'# do
+#    @terminology.should have_language_code 'en'
+#  end
 end
Index: /ruby/trunk/spec/models/territory_spec.rb
===================================================================
--- /ruby/trunk/spec/models/territory_spec.rb	(revision 420)
+++ /ruby/trunk/spec/models/territory_spec.rb	(revision 420)
@@ -0,0 +1,34 @@
+require 'spec_helper'
+
+describe Territory do
+  fixtures :territories
+
+  before(:each) do
+    @valid_attributes = {
+      :text => "Japan",
+      :three_letter => "JPN",
+      :numeric_code => "392",
+      :two_letter => "JP"
+    }
+  end
+
+  it "should create a new instance given valid attributes" do
+    Territory.create!(@valid_attributes)
+  end
+
+  it 'should return true if three letter code is on the table' do
+    Territory.should have_three_letter 'AFG'
+  end
+
+  it 'should return false if three leter code is out of the table' do
+    Territory.should_not have_three_letter 'ZZZ'
+  end
+
+  it 'should return true if two letter code is on the table' do
+    Territory.should have_two_letter 'AF'
+  end
+
+  it 'should return false if two letter code is out of the table' do
+    Territory.should_not have_two_letter 'ZZ'
+  end
+end